# HOW TO USE:
# 1. Run "/scoreboard players set min fallingblocks <minimum number>" to set a minimum number
# 2. Run "/scoreboard players set max fallingblocks <maximum number>" to set a maximum number
# 3. Run "/function <your_pack_name>:fallingblocks" to generate the number
# 4. Your ranom number between the given minimum and maximum is now stored as "out" in "fallingblocks"
# (Get it with "/scoreboard players operation <PLAYER> <SCOREBOARD> = out fallingblocks")
#
# *You don't need to set the minimum and maximum every time, it'll use the last used
# or the base which is min 0, max 100


# Activate the pack
execute unless entity @e[tag=fallingblocksactive] run scoreboard objectives add fallingblocks dummy
execute unless entity @e[tag=fallingblocksactive] run scoreboard players set min fallingblocks 0
execute unless entity @e[tag=fallingblocksactive] run scoreboard players set max fallingblocks 52
execute unless entity @e[tag=fallingblocksactive] run summon area_effect_cloud ~ ~ ~ {Tags:["fallingblocksbase"],Duration:1}
execute unless entity @e[tag=fallingblocksactive] run execute store result score num fallingblocks run data get entity @e[type=area_effect_cloud,limit=1,tag=fallingblocksbase] UUID[0]
execute unless entity @e[tag=fallingblocksactive] run scoreboard players set a fallingblocks 48141429
execute unless entity @e[tag=fallingblocksactive] run scoreboard players set b fallingblocks 4819982
execute unless entity @e[tag=fallingblocksactive] run scoreboard players set m fallingblocks 924866
execute unless entity @e[tag=fallingblocksactive] run execute at @a run summon minecraft:marker ~ ~ ~ {Tags:["fallingblocksactive"]}

# Prepare to use a minimum different from 0
scoreboard players operation trueMax fallingblocks = max fallingblocks
scoreboard players operation trueMax fallingblocks -= min fallingblocks
scoreboard players add trueMax fallingblocks 1

# Modify output
scoreboard players operation num fallingblocks *= a fallingblocks
scoreboard players operation num fallingblocks += b fallingblocks
scoreboard players operation out fallingblocks = num fallingblocks
scoreboard players operation out fallingblocks %= m fallingblocks
scoreboard players operation out fallingblocks %= trueMax fallingblocks
scoreboard players operation out fallingblocks += min fallingblocks

# Uncomment (remove the "# ") next line to print output
# tellraw @a {"score":{"name":"out","objective":"fallingblocks"}}

# This module was made by Natural_Power
# You may use it any way you want as long as these stay inside the module

execute if score out fallingblocks matches 1 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:grass_block}}
execute if score out fallingblocks matches 2 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:grass_block}}
execute if score out fallingblocks matches 3 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:dirt}}
execute if score out fallingblocks matches 4 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:dirt}}
execute if score out fallingblocks matches 5 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:sand}}
execute if score out fallingblocks matches 6 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:sand}}
execute if score out fallingblocks matches 7 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:oak_planks}}
execute if score out fallingblocks matches 8 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:stripped_oak_log}}
execute if score out fallingblocks matches 9 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:oak_stairs}}
execute if score out fallingblocks matches 10 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:oak_slab}}
execute if score out fallingblocks matches 11 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:oak_wood}}
execute if score out fallingblocks matches 12 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:stripped_oak_wood}}
execute if score out fallingblocks matches 13 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:birch_planks}}
execute if score out fallingblocks matches 14 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:stripped_birch_log}}
execute if score out fallingblocks matches 15 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:birch_stairs}}
execute if score out fallingblocks matches 16 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:birch_slab}}
execute if score out fallingblocks matches 17 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:birch_wood}}
execute if score out fallingblocks matches 18 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:stripped_birch_wood}}
execute if score out fallingblocks matches 19 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:mangrove_planks}}
execute if score out fallingblocks matches 20 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:stripped_mangrove_log}}
execute if score out fallingblocks matches 21 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:mangrove_stairs}}
execute if score out fallingblocks matches 22 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:mangrove_slab}}
execute if score out fallingblocks matches 23 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:mangrove_wood}}
execute if score out fallingblocks matches 24 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:stripped_mangrove_wood}}
execute if score out fallingblocks matches 25 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:cherry_planks}}
execute if score out fallingblocks matches 26 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:stripped_cherry_log}}
execute if score out fallingblocks matches 27 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:cherry_stairs}}
execute if score out fallingblocks matches 28 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:cherry_slab}}
execute if score out fallingblocks matches 29 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:cherry_wood}}
execute if score out fallingblocks matches 30 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:stripped_cherry_wood}}
execute if score out fallingblocks matches 31 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:jungle_planks}}
execute if score out fallingblocks matches 32 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:stripped_jungle_log}}
execute if score out fallingblocks matches 33 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:jungle_stairs}}
execute if score out fallingblocks matches 34 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:jungle_slab}}
execute if score out fallingblocks matches 35 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:jungle_wood}}
execute if score out fallingblocks matches 36 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:stripped_jungle_wood}}
execute if score out fallingblocks matches 37 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:white_wool}}
execute if score out fallingblocks matches 38 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:yellow_wool}}
execute if score out fallingblocks matches 39 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:black_wool}}
execute if score out fallingblocks matches 40 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:pink_wool}}
execute if score out fallingblocks matches 41 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:command_block}}
execute if score out fallingblocks matches 42 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:sculk_catalyst}}
execute if score out fallingblocks matches 43 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:anvil}}
execute if score out fallingblocks matches 44 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:pointed_dripstone}}
execute if score out fallingblocks matches 45 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:campfire}}
execute if score out fallingblocks matches 46 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:cobblestone}}
execute if score out fallingblocks matches 47 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:cobbled_deepslate}}
execute if score out fallingblocks matches 48 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:bedrock}}
execute if score out fallingblocks matches 49 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:red_wool}}
execute if score out fallingblocks matches 50 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:purple_wool}}
execute if score out fallingblocks matches 51 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:blue_wool}}
execute if score out fallingblocks matches 52 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:light_gray_wool}}
execute if score out fallingblocks matches 53 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:coal_ore}}
execute if score out fallingblocks matches 54 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:iron_ore}}
execute if score out fallingblocks matches 55 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:copper_ore}}
execute if score out fallingblocks matches 56 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:diamond_ore}}
execute if score out fallingblocks matches 57 positioned ~ ~ ~ run summon falling_block ~ ~ ~ {BlockState:{Name:gold_ore}}